namespace Ryujinx.Graphics.Gpu
{
    public enum NsGpuRegister
    {
        BindChannel               = 0,

        _2dClipEnable             = 0x0290,
        _2dOperation              = 0x02ac,

        _3dGlobalBase             = 0x02c8,
        _3dRt0AddressHigh         = 0x0800,
        _3dRt0AddressLow          = 0x0804,
        _3dRt0Horiz               = 0x0808,
        _3dRt0Vert                = 0x080c,
        _3dRt0Format              = 0x0810,
        _3dRt0BlockDimensions     = 0x0814,
        _3dRt0ArrayMode           = 0x0818,
        _3dRt0LayerStride         = 0x081c,
        _3dRt0BaseLayer           = 0x0820,
        _3dViewportScaleX         = 0x0a00,
        _3dViewportScaleY         = 0x0a04,
        _3dViewportScaleZ         = 0x0a08,
        _3dViewportTranslateX     = 0x0a0c,
        _3dViewportTranslateY     = 0x0a10,
        _3dViewportTranslateZ     = 0x0a14,
        _3dViewportHoriz          = 0x0c00,
        _3dViewportVert           = 0x0c04,
        _3dDepthRangeNear         = 0x0c08,
        _3dDepthRangeFar          = 0x0c0c,
        _3dClearColorR            = 0x0d80,
        _3dClearColorG            = 0x0d84,
        _3dClearColorB            = 0x0d88,
        _3dClearColorA            = 0x0d8c,
        _3dScreenScissorHoriz     = 0x0ff4,
        _3dScreenScissorVert      = 0x0ff8,
        _3dVertexAttrib0Format    = 0x1160,
        _3dVertexAttrib1Format    = 0x1164,
        _3dVertexAttrib2Format    = 0x1168,
        _3dVertexAttrib3Format    = 0x116c,
        _3dVertexAttrib4Format    = 0x1170,
        _3dVertexAttrib5Format    = 0x1174,
        _3dVertexAttrib6Format    = 0x1178,
        _3dVertexAttrib7Format    = 0x117c,
        _3dVertexAttrib8Format    = 0x1180,
        _3dVertexAttrib9Format    = 0x1184,
        _3dVertexAttrib10Format   = 0x1188,
        _3dVertexAttrib11Format   = 0x118c,
        _3dVertexAttrib12Format   = 0x1190,
        _3dVertexAttrib13Format   = 0x1194,
        _3dVertexAttrib14Format   = 0x1198,
        _3dVertexAttrib15Format   = 0x119c,
        _3dScreenYControl         = 0x13ac,
        _3dTscAddressHigh         = 0x155c,
        _3dTscAddressLow          = 0x1560,
        _3dTscLimit               = 0x1564,
        _3dTicAddressHigh         = 0x1574,
        _3dTicAddressLow          = 0x1578,
        _3dTicLimit               = 0x157c,
        _3dMultiSampleMode        = 0x15d0,
        _3dVertexEndGl            = 0x1614,
        _3dVertexBeginGl          = 0x1618,
        _3dQueryAddressHigh       = 0x1b00,
        _3dQueryAddressLow        = 0x1b04,
        _3dQuerySequence          = 0x1b08,
        _3dQueryGet               = 0x1b0c,
        _3dVertexArray0Fetch      = 0x1c00,
        _3dVertexArray0StartHigh  = 0x1c04,
        _3dVertexArray0StartLow   = 0x1c08,
        _3dVertexArray1Fetch      = 0x1c10, //todo: the rest
        _3dVertexArray0LimitHigh  = 0x1f00,
        _3dVertexArray0LimitLow   = 0x1f04,
        _3dCbSize                 = 0x2380,
        _3dCbAddressHigh          = 0x2384,
        _3dCbAddressLow           = 0x2388,
        _3dCbPos                  = 0x238c,
        _3dCbData0                = 0x2390,
        _3dCbData1                = 0x2394,
        _3dCbData2                = 0x2398,
        _3dCbData3                = 0x239c,
        _3dCbData4                = 0x23a0,
        _3dCbData5                = 0x23a4,
        _3dCbData6                = 0x23a8,
        _3dCbData7                = 0x23ac,
        _3dCbData8                = 0x23b0,
        _3dCbData9                = 0x23b4,
        _3dCbData10               = 0x23b8,
        _3dCbData11               = 0x23bc,
        _3dCbData12               = 0x23c0,
        _3dCbData13               = 0x23c4,
        _3dCbData14               = 0x23c8,
        _3dCbData15               = 0x23cc,
    }
}